<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LImportedDirectoryUriCatalogs StructType
 * @subpackage Structs
 */
class LImportedDirectoryUriCatalogs extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The routeString
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $routeString;
    /**
     * The lastLoadedFileName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $lastLoadedFileName;
    /**
     * The fileLoadDateTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fileLoadDateTime;
    /**
     * The uuid
     * Meta informations extracted from the WSDL
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for LImportedDirectoryUriCatalogs
     * @uses LImportedDirectoryUriCatalogs::setName()
     * @uses LImportedDirectoryUriCatalogs::setDescription()
     * @uses LImportedDirectoryUriCatalogs::setRouteString()
     * @uses LImportedDirectoryUriCatalogs::setLastLoadedFileName()
     * @uses LImportedDirectoryUriCatalogs::setFileLoadDateTime()
     * @uses LImportedDirectoryUriCatalogs::setUuid()
     * @param string $name
     * @param string $description
     * @param string $routeString
     * @param string $lastLoadedFileName
     * @param string $fileLoadDateTime
     * @param string $uuid
     */
    public function __construct($name = null, $description = null, $routeString = null, $lastLoadedFileName = null, $fileLoadDateTime = null, $uuid = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setRouteString($routeString)
            ->setLastLoadedFileName($lastLoadedFileName)
            ->setFileLoadDateTime($fileLoadDateTime)
            ->setUuid($uuid);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return LImportedDirectoryUriCatalogs
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return LImportedDirectoryUriCatalogs
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get routeString value
     * @return string|null
     */
    public function getRouteString()
    {
        return $this->routeString;
    }
    /**
     * Set routeString value
     * @param string $routeString
     * @return LImportedDirectoryUriCatalogs
     */
    public function setRouteString($routeString = null)
    {
        // validation for constraint: string
        if (!is_null($routeString) && !is_string($routeString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($routeString)), __LINE__);
        }
        $this->routeString = $routeString;
        return $this;
    }
    /**
     * Get lastLoadedFileName value
     * @return string|null
     */
    public function getLastLoadedFileName()
    {
        return $this->lastLoadedFileName;
    }
    /**
     * Set lastLoadedFileName value
     * @param string $lastLoadedFileName
     * @return LImportedDirectoryUriCatalogs
     */
    public function setLastLoadedFileName($lastLoadedFileName = null)
    {
        // validation for constraint: string
        if (!is_null($lastLoadedFileName) && !is_string($lastLoadedFileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastLoadedFileName)), __LINE__);
        }
        $this->lastLoadedFileName = $lastLoadedFileName;
        return $this;
    }
    /**
     * Get fileLoadDateTime value
     * @return string|null
     */
    public function getFileLoadDateTime()
    {
        return $this->fileLoadDateTime;
    }
    /**
     * Set fileLoadDateTime value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $fileLoadDateTime
     * @return LImportedDirectoryUriCatalogs
     */
    public function setFileLoadDateTime($fileLoadDateTime = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($fileLoadDateTime)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $fileLoadDateTime, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->fileLoadDateTime = $fileLoadDateTime;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return LImportedDirectoryUriCatalogs
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: pattern
        if (is_scalar($uuid) && !preg_match('/\{........-....-....-....-............\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "\{........-....-....-....-............\}", "%s" given', var_export($uuid, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uuid)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return LImportedDirectoryUriCatalogs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
